;WOW!! This is my first useful assembly program. All it does is display a degree sign for
;degrees mode and a radian sign for radians mode. I made this because it was a pain in the
;butt to go to the mode screen and see which mode I was in for my whole FST (functions, stats,
;and trig) final. You could very easily change this program to do the same thing for any mode.

;Thanks to Jimmy Mardell for giving me a TON of help, and to whoever wrote the testint routine.
;If you use any of this source code in your program, you can give a little credit to me, but
;be sure to give MOST of the credit to those guys!

;//Brad Wissel

#include asm86.h
#include ti86asm.inc

_user_int_ram EQU $d2fd
_plot EQU $FC00+111  ;$FC00 is the first pixel, currently points 111 up from it

.org _asm_exec_ram
   res 2,(iy+$23)    ;turn user int off so it won't get called by
                     ;accident before we're ready
   
   ld hl,int         ;copy prog to user int buffer
   ld de,_user_int_ram+1
   ld bc,int_end-int
   ldir
   
   ld a,(_user_int_ram+1)  ;set up checksum byte
   ld hl,_user_int_ram+($28*1)
   add a,(hl)
   ld hl,_user_int_ram+($28*2)
   add a,(hl)
   ld hl,_user_int_ram+($28*3)
   add a,(hl)
   ld hl,_user_int_ram+($28*4)
   add a,(hl)
   ld hl,_user_int_ram+($28*5)
   add a,(hl)
   ld (_user_int_ram),a

   set 2,(iy+$23)    ;turn it on
   ret

int:                        ;you must do this or your calculator will crash!!
 push bc
 push hl
 push af

 bit trigdeg,(iy+trigflags) ;check to see how the mode flag is set, 0=radians 1=degrees
 jr z,radians               ;Thanks to Jimmy Mardell.
degrees:
 LD de,degree
 JR drawIt
radians:
 LD de,radian

drawIt:                     ;I have no idea how this works. It's all thanks to the master
 ld hl,_plot                ;of ASM, Jimmy Mardell (I do know that hl points where to
 ld b,6                     ;start drawing, however)
PutMoreImg:
 ld a,(de)
 inc de
 ld (hl),a
 push de
 ld de,16
 add hl,de
 pop de
 djnz PutMoreImg
 
ending:
 pop bc
 pop hl
 pop af
 RET

degree:                                 ;The only part of this amazing routine I figured out...
 .db %00000000,%00011000,%00100100      ;THE PICTURES!!
 .db %00100100,%00011000,%00000000

radian:
 .db %00000000,%00101100,%00110000
 .db %00100000,%00100000,%00000000

var1 equ $-int+_user_int_ram+1          ;counter with address adjusted for the
   .db 140,34                           ;interrupt handlers address
int_end:
          
.END


